var maxBarWidth = 80;

function InitDisplay(view)
{
	var updateElement, j, k;
	var divId, viewItems, uiItems, uiItem, displayType, module;
	var output = "";

	g_initDisplay = false;
	updateElement = document.getElementById(view.getName()+'Values');

	if (updateElement != null)
	{
		viewItems = view.getItems();
		output +="<table border='0'>";
		for (j = 0; j < viewItems.length; j++)
		{
			uiItems = viewItems[j].getItems();
			displayType = viewItems[j].getDisplayType();			
			divId = "div"+view.getName()+"_" + displayType;
			output += "<tr><td colspan=\"7\" style=\"border:0;\"><b>" + viewItems[j].getDescription() + "</b></td></tr>";
			for (k = 0; k < uiItems.length; k++)
			{
				uiItem = uiItems[k];
				module = uiItem.getModule();
				if ((displayType == DisplayTypes.DigitalInput) || (displayType == DisplayTypes.DigitalOutput) || ((displayType == DisplayTypes.Virtual) && (uiItem.getValueType() == VirtualTypes.Digital)))
				{
					output += "<tr>";
					output += "<td width=\"50\">" + displayType + ":" + module + "." + uiItem.getBit() + "</td>";
					output += "<td width=\"150\">" + uiItem.getDescription() + "</td>";
					output += "<td width=\"60\"><div style=\"text-align: center;\" id=\"" +(divId+module+"_"+uiItem.getBit()) + "_rawValue\">[0]</div></td>";
					if (uiItem.getWriteable())
					{
						output += "<td colspan=\"2\" width=\"150\"><div id=\"" + (divId+module+"_"+uiItem.getBit()+"_status") + "\">&nbsp;</div></td>";
						output += "<td width=\"140\"><select valueType=\"Digital\" style=\"width:58px;\" id=\""+ displayType + "-" + module + "." + uiItem.getBit() +"\"><option value=\"1\">True</option><option value=\"0\">False</option></select>&nbsp;<input style=\"height:20px;\" type=\"button\" onClick=\"SendValues('"+ displayType + "-" + module + "." + uiItem.getBit() +"');\" value=\"Set\"></td>";
					}
					else
						output += "<td colspan=\"3\" width=\"290\"><div id=\"" + (divId+module+"_"+uiItem.getBit()+"_status") + "\">&nbsp;</div></td>";
					output += "</tr>";
				}
				else if ((displayType == DisplayTypes.AnalogueInput) || (displayType == DisplayTypes.AnalogueOutput) || ((displayType == DisplayTypes.Virtual) && (uiItem.getValueType() == VirtualTypes.Analogue)))
				{
					output += "<tr>";
					output += "<td width=\"50\">" + displayType + ":" + module + "</td>";
					output += "<td width=\"150\">" + uiItem.getDescription() +"</td>";
					output += "<td width=\"40\"><div style=\"text-align: center;\" id=\"" + (divId+module+"_scaledValue") + "\">&nbsp;</div></td><td width=\"60\">"+uiItem.getUnitText()+"</td>";
					output += "<td style=\"border: 1px solid grey;\" width=\"80\"><div style=\"background-color: green;width:0px;\" id=\"" + (divId+module+"_barValue") + "\">&nbsp;</div></td>";
					if (uiItem.getWriteable())
						output += "<td><input type=\"text\" valueType=\"Analogue\" scaleLow=\""+uiItem.getScaleLow()+"\" scaleHigh=\""+uiItem.getScaleHigh()+"\" onblur=\"this.value = VerifyValue(this.value, "+uiItem.getScaleLow()+","+uiItem.getScaleHigh()+")\" id=\"" +displayType + "-" + module +"\" maxlength=\"5\" style=\"width:58px;\">&nbsp;<input style=\"height:20px;\" type=\"button\" onClick=\"SendValues('"+displayType + "-" + module+"');\" value=\"Set\"></td>";
					else
						output += "<td>&nbsp;</td>";
					output += "</tr>";
				}
			}
			output += "<tr><td style=\"border:none;\" colspan=\"6\">&nbsp;</td></tr>";
		}
		output += "</table>";
		updateElement.innerHTML = output;
		updateElement.setAttribute("class", "showForm") || updateElement.setAttribute("className", "showForm");
	}		
}

function UpdateDisplay(newValues, view)
{
	var j,k, valueElement, statusElement, barElement, scaleElement, newValue, width = 0, displayType;
	var	viewItems, uiItems, uiItem;
	var divId = "";
	
	UpdateStatus();
	
	viewItems = view.getItems();
	for (j = 0; j < viewItems.length; j++)
	{
		uiItems = viewItems[j].getItems();
		displayType = viewItems[j].getDisplayType();
		for (k = 0; k < uiItems.length; k++)
		{
			uiItem = uiItems[k];
			newValue = extractValue("g_RTU32WTOOL32_"+displayType+"[\""+uiItem.getModule()+"\"]", newValues);
			
			if ((displayType == DisplayTypes.DigitalInput) || (displayType == DisplayTypes.DigitalOutput) || ((displayType == DisplayTypes.Virtual) && (uiItem.getValueType() == VirtualTypes.Digital)))
			{
				divId = "div" + view.getName() + "_" + displayType + uiItem.getModule() + "_" + uiItem.getBit();
				valueElement = document.getElementById(divId + "_rawValue");
				statusElement = document.getElementById(divId + "_status");
				if (valueElement != null)
				{
					valueElement.style.backgroundColor = (bit_test(newValue,uiItem.getBit()) ? uiItem.getOnColor() : uiItem.getOffColor());
					valueElement.innerHTML = (bit_test(newValue, uiItem.getBit()) ? "1" : "0");						
				}					
				if (statusElement != null)
					statusElement.innerHTML = (bit_test(newValue, uiItem.getBit()) ? uiItem.getOnText() : uiItem.getOffText());
			}
			else if ((displayType == DisplayTypes.AnalogueInput) || (displayType == DisplayTypes.AnalogueOutput) || ((displayType == DisplayTypes.Virtual) && (uiItem.getValueType() == VirtualTypes.Analogue)))
			{
				newValue &= (Math.pow(2, uiItem.getResolution())-1);
				divId = "div" + view.getName() + "_" + displayType + uiItem.getModule();
				barElement = document.getElementById(divId + "_barValue");
				scaledElement = document.getElementById(divId + "_scaledValue");
				if (barElement != null)
				{
					width = newValue * (maxBarWidth/uiItem.getMaxValue());
					barElement.innerHTML = uiItem.getPercentValue(newValue) + "%";
					barElement.setAttribute("style", "background-color: green;text-align: center;");
					barElement.style.width = parseInt(width,10) + "px";
				}
				if (scaledElement != null)
					scaledElement.innerHTML = uiItem.getScaledValue(newValue);
			}
		}
	}
}