function ShowRecordDescription(id){
	var recordElement = document.getElementById(id);
	var iconElement = document.getElementById("icon"+id);

	if (recordElement != null)
		if (recordElement.className == 'hideform')
		{
			recordElement.className = 'showform';
			if (iconElement != null)
				iconElement.src = "..//remoteadminimages//icon-collapse-minus.gif"
		}
		else
		{
			recordElement.className = 'hideform';
			if (iconElement != null)
				iconElement.src = "..//remoteadminimages//icon-collapse-plus.gif"			
		}
}
function AddPointType(pointType){
	var returnValue;
	switch (pointType){
		case "1":
			returnValue = "Binary Inputs:";
			break;
		case "3":
			returnValue = "Double binary Inputs:";
			break;
		case "10":
			returnValue = "Binary Outputs:";
			break;
		case "20":
			returnValue = "Counters:";
			break;
		case "30":
			returnValue = "Analogue Inputs:";
			break;
		case "40":
			returnValue = "Analogue Outputs:";
			break;
	}
	return returnValue;
}
function AddRecordType(recordType){
	var returnValue;
	switch (recordType){
		case 0:
			returnValue = "Device On/Off scan";
			break;
		case 1:
			returnValue = "Connection Detail";
			break;
		case 2:
			returnValue = "Scheduled Connection";
			break;
		case 1000:
			returnValue = "Point On/Off Scan";
			break;
		case 1001:
			returnValue = "Override Point";
			break;
		case 1002:
			returnValue = "Analogue Range/Scaling";
			break;
		case 1003:
			returnValue = "Analogue Limits";
			break;
		case 1004:
			returnValue = "Counter Limits";
			break;
		case 1005:
			returnValue = "Point Archives";
			break;
		case 1006:
			returnValue = "Binary States";
			break;
		case 1007:
			returnValue = "Profile";
			break;
		case 1008:
			returnValue = "Rate of Change";
			break;
		case 1009:
			returnValue = "DNP3 Object Flag Actions";
			break;
		case 1010:
			returnValue = "Minimum";
			break;
		case 1011:
			returnValue = "Maximum";
			break;
		case 1012:
			returnValue = "Mean";
			break;
		case 1013:
			returnValue = "Integral";
			break;
		case 1014:
			returnValue = "State Counter";
			break;
		case 1015:
			returnValue = "State Runtime";
			break;
		case 1016:
			returnValue = "Profile Control Value";
			break;
		case 1017:
			returnValue = "High Speed Sampled Data";
			break;
	}
	return returnValue;
}

function readFloatLE(buffer, offset, isBE, mLen, nBytes) {
  var e, m,
  eLen = nBytes * 8 - mLen - 1,
  eMax = (1 << eLen) - 1,
  eBias = eMax >> 1,
  nBits = -7,
  i = isBE ? 0 : (nBytes - 1),
  d = isBE ? 1 : -1,
  s = parseInt(buffer[offset + i],16);

  i += d;

  e = s & ((1 << (-nBits)) - 1);
  s >>= (-nBits);
  nBits += eLen;
  for (; nBits > 0; e = e * 256 + parseInt(buffer[offset + i],16), i += d, nBits -= 8);

  m = e & ((1 << (-nBits)) - 1);
  e >>= (-nBits);
  nBits += mLen;
  for (; nBits > 0; m = m * 256 + parseInt(buffer[offset + i],16), i += d, nBits -= 8);

  if (e === 0) {
    e = 1 - eBias;
  } else if (e === eMax) {
    return m ? NaN : ((s ? -1 : 1) * Infinity);
  } else {
    m = m + Math.pow(2, mLen);
    e = e - eBias;
  }
  return (s ? -1 : 1) * m * Math.pow(2, e - mLen);
}
function getFloat(index, values){
	return readFloatLE(values, index, false, 23, 4);
}
function getInt(index, values){
	return parseInt(values[index+1]+values[index],16);
}
function getLong(index, values){
	return parseInt(values[index+3]+values[index+2]+values[index+1]+values[index],16);
}
function parseASCII(index, length, values){
	var str = '';	
    for (var i = index; i < index+length; i++){
        if (parseInt(values[i],16) != 0)
			str += String.fromCharCode(parseInt(values[i],16));
	}
	if (str == "")
		str = '&nbsp;';
    return str;
}
function computeDayOfYear(pDateTime){
  var tempValue1 = parseInt((((pDateTime.getUTCMonth()+1 + 9) / 12)));
  var tempValue2 = parseInt((1 + (((pDateTime.getUTCFullYear()%4) + 2) / 3)));
  var tempValue3 = parseInt((((pDateTime.getUTCMonth()+1)*275) / 9));
  if (tempValue1 < 0) tempValue1 *=-1;
  if (tempValue2 < 0) tempValue2 *=-1;
  if (tempValue3 < 0) tempValue3 *=-1;
  var returnValue = (((tempValue3 - (tempValue1 * tempValue2)) + pDateTime.getUTCDate() - 30));
  return parseInt(returnValue);
}
function parseUTC(index, values){
	var least = getInt(index, values);
	var most = getLong(index+2, values);
	var returnDate = new Date();
	var tmp1 = (((most % 60000) << 16) >>> 0);
	var tmp2 = (((most / 60000) << 16) >>> 0) + ((tmp1 + least) / 60000);
	
	returnDate.setUTCMilliseconds(0);
	returnDate.setUTCSeconds(((tmp1 + least) % 60000)/1000);
	returnDate.setUTCMinutes(tmp2 % 60);
	tmp2 = parseInt(tmp2 / 60);
	returnDate.setUTCHours(tmp2%24);
	tmp2 = parseInt(tmp2 / 24);
	returnDate.setUTCFullYear(parseInt((tmp2/365)+1970));
	
	tmp1 = parseInt(((returnDate.getUTCFullYear() - 1970) * 365) + ((returnDate.getUTCFullYear() - 1969) / 4));
	
	while (tmp1 > tmp2){
		returnDate.setFullYear(returnDate.getUTCFullYear()-1);
		tmp1 = parseInt(((returnDate.getUTCFullYear() - 1970) * 365) + ((returnDate.getUTCFullYear() - 1969) / 4));	
	}
	tmp2 = parseInt(tmp2 - tmp1 + 1);
	returnDate.setUTCMonth(parseInt((tmp2/28)));
	returnDate.setUTCDate(parseInt((tmp2%28)+1));
	
	while (computeDayOfYear(returnDate) != tmp2){
		var newDate = returnDate.getUTCDate()-1;
		if (newDate == 0){
			returnDate.setUTCMonth(returnDate.getUTCMonth()-1);
			returnDate.setUTCDate(31);
		}
		else
			returnDate.setUTCDate(newDate);
	}
	
	return returnDate.toUTCString();
}
//Parse Records
function parseRecord0(index, byteCount){
	Add2ColTRTDAttr("width=\"150px\"","On/Off Scan flag", parseInt(g_HexByte[index],16));
}
function parseRecord1(index, byteCount){
	Add2ColTRTDAttr("width=\"150px\"","Index:", parseInt(g_HexByte[index],16));
	Add2ColTRTDAttr("width=\"150px\"","Port Number:", parseInt(g_HexByte[index+1],16));
	Add2ColTRTDAttr("width=\"150px\"","Connection Mode:", parseInt(g_HexByte[index+2],16));
	Add2ColTRTDAttr("width=\"150px\"","Dial-up Number:", parseASCII(index+3, 20, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Network Protocol:", parseInt(g_HexByte[index+23],16));
	Add2ColTRTDAttr("width=\"150px\"","Network End Point Type:", parseInt(g_HexByte[index+24], 16));
	Add2ColTRTDAttr("width=\"150px\"","Network Information:", parseASCII(index+25, 48, g_HexByte));
}
function parseRecord2(index, byteCount){
	Add2ColTRTDAttr("width=\"150px\"","Start Time",parseUTC(index, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Repeat Interval", getInt(index+6, g_HexByte));
}
function parseRecord1000(index, byteCount){
	Add2ColTRTDAttr("width=\"150px\"","Point Type:", parseInt(g_HexByte[index],16));
	Add2ColTRTDAttr("width=\"150px\"","Point Number:", parseInt(g_HexByte[index+2] + g_HexByte[index+1],16));
	Add2ColTRTDAttr("width=\"150px\"","On/Off Scan Flag:", parseInt(g_HexByte[index+3],16));
}
function parseRecord1001(index, byteCount){
	var pointType = parseInt(g_HexByte[index],16);
	
	Add2ColTRTDAttr("width=\"150px\"","Point Type:",pointType);
	Add2ColTRTDAttr("width=\"150px\"","Point Number:",parseInt(g_HexByte[index+2] + g_HexByte[index+1],16));
	Add2ColTRTDAttr("width=\"150px\"","Action:", parseInt(g_HexByte[index+3],16));
	if (byteCount == 8)
		Add2ColTRTDAttr("width=\"150px\"","Override value:", (pointType < 30)?getLong(index+4, g_HexByte):getFloat(index+4, g_HexByte));
	else
		Add2ColTRTDAttr("width=\"150px\"","Override value:", "<i>Disabled</i>");
}
function parseRecord1002(index, byteCount){
	var rawDataType = 0;
	Add2ColTRTDAttr("width=\"150px\"","Point Type:",parseInt(g_HexByte[index],16));
	Add2ColTRTDAttr("width=\"150px\"","Point Number:",parseInt(g_HexByte[index+2] + g_HexByte[index+1],16));
	rawDataType = parseInt(g_HexByte[index+3],16)
	Add2ColTRTDAttr("width=\"150px\"","Raw Data Type:",rawDataType);
	Add2ColTRTDAttr("width=\"150px\"","Raw Scale 1:",(rawDataType==2)?getFloat(index+4, g_HexByte):getInt(index+4, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Raw Scale 2:",(rawDataType==2)?getFloat(index+8, g_HexByte):getInt(index+8, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Engineering Scale 1:",getFloat(index+12, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Engineering Scale 2:",getFloat(index+16, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Range Minimum:",getFloat(index+20, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Range Maximum:",getFloat(index+24, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Units:", parseASCII(index+28, 10, g_HexByte));
}
function parseRecord1003(index, byteCount){
	Add2ColTRTDAttr("width=\"150px\"","Point Type:",parseInt(g_HexByte[index],16));
	Add2ColTRTDAttr("width=\"150px\"","Point Number:",getInt(index+1, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Point Limit Index:",parseInt(g_HexByte[index+3],16));
	Add2ColTRTDAttr("width=\"150px\"","Direction:",parseInt(g_HexByte[index+4],16));
	Add2ColTRTDAttr("width=\"150px\"","Limit Value:", getFloat(index+5,g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Profile Number 1:", parseInt(g_HexByte[index+9],16));
	Add2ColTRTDAttr("width=\"150px\"","Profile Number 2:", parseInt(g_HexByte[index+10],16));
	Add2ColTRTDAttr("width=\"150px\"","Profile Number 3:", parseInt(g_HexByte[index+11],16));
	Add2ColTRTDAttr("width=\"150px\"","Profile Number 4:", parseInt(g_HexByte[index+12],16));
	Add2ColTRTDAttr("width=\"150px\"","Profile Number 5:", parseInt(g_HexByte[index+13],16));
	Add2ColTRTDAttr("width=\"150px\"","Profile Number 6:", parseInt(g_HexByte[index+14],16));
	Add2ColTRTDAttr("width=\"150px\"","Profile Number 7:", parseInt(g_HexByte[index+15],16));
	Add2ColTRTDAttr("width=\"150px\"","Action:", parseInt(g_HexByte[index+16],16));
	Add2ColTRTDAttr("width=\"150px\"","Hysteresis:", getFloat(index+17, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Enter Persistence:", getLong(index+21, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Leave Persistence:", getLong(index+25, g_HexByte));
}
function parseRecord1004(index, byteCount){
	Add2ColTRTDAttr("width=\"150px\"","Point Type:",parseInt(g_HexByte[index],16));
	Add2ColTRTDAttr("width=\"150px\"","Point Number:",getInt(index+1, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Point Limit Index:",parseInt(g_HexByte[index+3],16));
	Add2ColTRTDAttr("width=\"150px\"","Limit Value:", getLong(index+4, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Profile Number 1:", parseInt(g_HexByte[index+8],16));
	Add2ColTRTDAttr("width=\"150px\"","Profile Number 2:", parseInt(g_HexByte[index+9],16));
	Add2ColTRTDAttr("width=\"150px\"","Profile Number 3:", parseInt(g_HexByte[index+10],16));
	Add2ColTRTDAttr("width=\"150px\"","Profile Number 4:", parseInt(g_HexByte[index+11],16));
	Add2ColTRTDAttr("width=\"150px\"","Profile Number 5:", parseInt(g_HexByte[index+12],16));
	Add2ColTRTDAttr("width=\"150px\"","Profile Number 6:", parseInt(g_HexByte[index+13],16));
	Add2ColTRTDAttr("width=\"150px\"","Profile Number 7:", parseInt(g_HexByte[index+14],16));
	Add2ColTRTDAttr("width=\"150px\"","Action:", parseInt(g_HexByte[index+15],16));
}
function parseRecord1005(index, byteCount){
	Add2ColTRTDAttr("width=\"150px\"","Point Type:",parseInt(g_HexByte[index],16));
	Add2ColTRTDAttr("width=\"150px\"","Point Number:",getInt(index+1, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Periodic Rate:",getInt(index+3, g_HexByte));
	if (byteCount == 9)
		Add2ColTRTDAttr("width=\"150px\"","Periodic Log Offset:",getLong(index+5, g_HexByte));
}
function parseRecord1006(index, byteCount){
	Add2ColTRTDAttr("width=\"150px\"","Point Type:",parseInt(g_HexByte[index],16));
	Add2ColTRTDAttr("width=\"150px\"","Point Number:",getInt(index+1, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","State 0 Action:",parseInt(g_HexByte[index+3],16));
	Add2ColTRTDAttr("width=\"150px\"","State 0 Persistence:", getLong(index+4, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","State 1 Action:",parseInt(g_HexByte[index+8],16));
	Add2ColTRTDAttr("width=\"150px\"","State 1 Persistence:", getLong(index+9, g_HexByte));
	if (byteCount == 23){
		Add2ColTRTDAttr("width=\"150px\"","State 2 Action:",parseInt(g_HexByte[index+13],16));
		Add2ColTRTDAttr("width=\"150px\"","State 2 Persistence:", getLong(index+14, g_HexByte));
		Add2ColTRTDAttr("width=\"150px\"","State 3 Action:",parseInt(g_HexByte[index+18],16));
		Add2ColTRTDAttr("width=\"150px\"","State 3 Persistence:", getLong(index+19, g_HexByte));
	}
}
function parseRecord1007(index, byteCount){
	var i;
	Add2ColTRTDAttr("width=\"150px\"","Profile Number:",parseInt(g_HexByte[index],16));
	var valueType = parseInt(g_HexByte[index+1],16);
	Add2ColTRTDAttr("width=\"150px\"","Value Type:",valueType);
	var numberOfVectors = getInt(index+2, g_HexByte);
	Add2ColTRTDAttr("width=\"150px\"","Nr. of Vectors:", numberOfVectors);
	Add2ColTRTDAttr("width=\"150px\"","Time:", "Value:");
	for (i = 0; i < numberOfVectors; i++)
		Add2ColTRTDAttr("width=\"150px\"",getInt((index+4+(i*6)), g_HexByte), (valueType == 0)?getFloat((index+6+(i*6)), g_HexByte):getLong((index+6+(i*6)), g_HexByte));
}
function parseRecord1008(index, byteCount){
	var pointType = parseInt(g_HexByte[index],16);
	Add2ColTRTDAttr("width=\"150px\"","Point Type:",pointType);
	Add2ColTRTDAttr("width=\"150px\"","Point Number:",getInt(index+1, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","ROC Period:",getLong(index+3, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","ROC Time Base:",parseInt(g_HexByte[index+7], 16));
	Add2ColTRTDAttr("width=\"150px\"","ROC Point Number:",getInt(index+8, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","No Change Period:",getLong(index+10, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","No Change Deadband:",(pointType == 20)?getLong(index+14, g_HexByte):getFloat(index+14, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","No Change Point Number:",getInt(index+18, g_HexByte));
}
function parseRecord1009(index, byteCount){
	Add2ColTRTDAttr("width=\"150px\"","Point Type:",parseInt(g_HexByte[index],16));
	Add2ColTRTDAttr("width=\"150px\"","Point Number:",getInt(index+1, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Bit 0 Action", parseInt(g_HexByte[index+3],16));
	Add2ColTRTDAttr("width=\"150px\"","Bit 1 Action", parseInt(g_HexByte[index+4],16));
	Add2ColTRTDAttr("width=\"150px\"","Bit 2 Action", parseInt(g_HexByte[index+5],16));
	Add2ColTRTDAttr("width=\"150px\"","Bit 3 Action", parseInt(g_HexByte[index+6],16));
	Add2ColTRTDAttr("width=\"150px\"","Bit 4 Action", parseInt(g_HexByte[index+7],16));
	Add2ColTRTDAttr("width=\"150px\"","Bit 5 Action", parseInt(g_HexByte[index+8],16));
	Add2ColTRTDAttr("width=\"150px\"","Bit 6 Action", parseInt(g_HexByte[index+9],16));
	Add2ColTRTDAttr("width=\"150px\"","Bit 7 Action", parseInt(g_HexByte[index+10],16));
}
function parseRecord1010(index, byteCount){
	Add2ColTRTDAttr("width=\"150px\"","Point Type:",parseInt(g_HexByte[index],16));
	Add2ColTRTDAttr("width=\"150px\"","Point Number:",getInt(index+1, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Mode:", parseInt(g_HexByte[index+3], 16));
	if (byteCount == 14){
		Add2ColTRTDAttr("width=\"150px\"","Period:", getLong(index+4, g_HexByte));
		Add2ColTRTDAttr("width=\"150px\"","Offset:", getLong(index+8, g_HexByte));
		Add2ColTRTDAttr("width=\"150px\"","Min. Point number:", getInt(index+12, g_HexByte));
	}
}
function parseRecord1011(index, byteCount){
	Add2ColTRTDAttr("width=\"150px\"","Point Type:",parseInt(g_HexByte[index],16));
	Add2ColTRTDAttr("width=\"150px\"","Point Number:",getInt(index+1, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Mode:", parseInt(g_HexByte[index+3], 16));
	if (byteCount == 14){
		Add2ColTRTDAttr("width=\"150px\"","Period:", getLong(index+4, g_HexByte));
		Add2ColTRTDAttr("width=\"150px\"","Offset:", getLong(index+8, g_HexByte));
		Add2ColTRTDAttr("width=\"150px\"","Max. Point number:", getInt(index+12, g_HexByte));
	}
}
function parseRecord1012(index, byteCount){
	Add2ColTRTDAttr("width=\"150px\"","Point Type:",parseInt(g_HexByte[index],16));
	Add2ColTRTDAttr("width=\"150px\"","Point Number:",getInt(index+1, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Mode:", parseInt(g_HexByte[index+3], 16));
	if (byteCount == 14){
		Add2ColTRTDAttr("width=\"150px\"","Period:", getLong(index+4, g_HexByte));
		Add2ColTRTDAttr("width=\"150px\"","Offset:", getLong(index+8, g_HexByte));
		Add2ColTRTDAttr("width=\"150px\"","Mean Point number:", getInt(index+12, g_HexByte));
	}
}
function parseRecord1013(index, byteCount){
	Add2ColTRTDAttr("width=\"150px\"","Point Type:",parseInt(g_HexByte[index],16));
	Add2ColTRTDAttr("width=\"150px\"","Point Number:",getInt(index+1, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Period:", getLong(index+3, g_HexByte));
	if (byteCount == 13){
		Add2ColTRTDAttr("width=\"150px\"","Offset:", getLong(index+7, g_HexByte));
		Add2ColTRTDAttr("width=\"150px\"","Int. Point number:", getInt(index+11, g_HexByte));
		//		
	}
}
function parseRecord1014(index,byteCount){
	Add2ColTRTDAttr("width=\"150px\"","Point Type:",parseInt(g_HexByte[index],16));
	Add2ColTRTDAttr("width=\"150px\"","Point Number:",getInt(index+1, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","State Mask", getInt(index+3, g_HexByte));
	if (byteCount == 15){
		Add2ColTRTDAttr("width=\"150px\"","Period:", getLong(index+5, g_HexByte));
		Add2ColTRTDAttr("width=\"150px\"","Offset:", getLong(index+9, g_HexByte));
		Add2ColTRTDAttr("width=\"150px\"","Cnt. Point number:", getInt(index+13, g_HexByte));
		//
	}
}
function parseRecord1015(index,byteCount){
	Add2ColTRTDAttr("width=\"150px\"","Point Type:",parseInt(g_HexByte[index],16));
	Add2ColTRTDAttr("width=\"150px\"","Point Number:",getInt(index+1, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","State Mask", getInt(index+3, g_HexByte));
	if (byteCount == 15){
		Add2ColTRTDAttr("width=\"150px\"","Period:", getLong(index+5, g_HexByte));
		Add2ColTRTDAttr("width=\"150px\"","Offset:", getLong(index+9, g_HexByte));
		Add2ColTRTDAttr("width=\"150px\"","Runtime Point number:", getInt(index+13, g_HexByte));
		//
	}
}
function parseRecord1016(index,byteCount){
	Add2ColTRTDAttr("width=\"150px\"","Point Type:",parseInt(g_HexByte[index],16));
	Add2ColTRTDAttr("width=\"150px\"","Point Number:",getInt(index+1, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Profile Number 1:", parseInt(g_HexByte[index+3],16));
	Add2ColTRTDAttr("width=\"150px\"","Profile Number 2:", parseInt(g_HexByte[index+4],16));
	Add2ColTRTDAttr("width=\"150px\"","Profile Number 3:", parseInt(g_HexByte[index+5],16));
	Add2ColTRTDAttr("width=\"150px\"","Profile Number 4:", parseInt(g_HexByte[index+6],16));
	Add2ColTRTDAttr("width=\"150px\"","Profile Number 5:", parseInt(g_HexByte[index+7],16));
	Add2ColTRTDAttr("width=\"150px\"","Profile Number 6:", parseInt(g_HexByte[index+8],16));
	Add2ColTRTDAttr("width=\"150px\"","Profile Number 7:", parseInt(g_HexByte[index+9],16));
	Add2ColTRTDAttr("width=\"150px\"","Interpolation time:", parseInt(g_HexByte[index+10],16));
}
function parseRecord1017(index,byteCount){
	Add2ColTRTDAttr("width=\"150px\"","Point Type:",parseInt(g_HexByte[index],16));
	Add2ColTRTDAttr("width=\"150px\"","Point Number:",getInt(index+1, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Sampling Rate:",getLong(index+3, g_HexByte));
	Add2ColTRTDAttr("width=\"150px\"","Cycle:", getInt(index+7, g_HexByte));
}