﻿
//Copyright (c) Brodersen Systems A/S. All rights reserved.
//Written by Beggi Oskarsson
// ------
// 1.50B6 2011/04/05  BO	parseInt used instead of "/re = /\w+/; // search for number" as
//                        negative numbers where not read correctly.

if ('undefined'==typeof(aDevArr)) {aDevArr = new Array();}
if ('undefined'==typeof(aDiArr)) {aDiArr = new Array();}
if ('undefined'==typeof(aDoArr)) {aDoArr = new Array();}
if ('undefined'==typeof(aAiArr)) {aAiArr = new Array();}
if ('undefined'==typeof(aAoArr)) {aAoArr = new Array();}

var OID_RTU32 = "1.3.6.1.4.1.24122.2";
var DeviceSize = 6,
		InpBoolSize = 16,
		OutBoolSize = 16,
		InpIntSize  = 16,
		OutIntSize  = 16;
		
var SnmpDi=1, SnmpDo=2, SnmpAi=3, SnmpAo=4;

// Define constants ("const" is not supported in IE6 only in FireFox")
//var diIndx=0; //, diDes=1, diMsg=2, diPri=3, diTTy=4, diOri=5, diMod=6, diBit=7, diFun=8, diTRe=9, diDel=10;
//var doIndx=0; //, doDes=1, doMsg=2, doPri=3, doTTy=4, doOri=5, doMod=6, doBit=7, doFun=8, doTRe=9;
var piIndx=0, piDes=1, piMsg=2, piPri=3, piTTy=4, piOri=5, piMod=6, piBit=7, piFun=8, piTRe=9, piDel=10; piTIP=11;
var piLLL=12, piLoL=13, piHiL=14, piHHL=15, piSMi=16, piSMa=17, piAMi=18, piAMa=19;

function DefaultIO(IoName,iIndx)
	{
	lArr = new Array();
	lArr[piIndx] = iIndx;
	lArr[piDes ] = IoName+iIndx;
	lArr[piMsg ] = "";
	lArr[piPri ] = 1;
	lArr[piTTy ] = 0;
	lArr[piOri ] = 2;  // default=1 DI/DO/AI/AO=2 VIO=3
	lArr[piMod ] = 0;
	lArr[piBit ] = 0;	               
	lArr[piFun ] = 0;
	lArr[piTRe ] = 0;
	lArr[piDel ] = 0;
	lArr[piTIP ] = "";
   // Only for analog IO
	lArr[piLLL ] = 0;
	lArr[piLoL ] = 0;
	lArr[piHiL ] = 16383;
	lArr[piHHL ] = 16383;
	lArr[piSMi ] = 0;
	lArr[piSMa ] = 16383;
	lArr[piAMi ] = 0;
	lArr[piAMa ] = 16383;
	return lArr;
	}
	
function F_InDevices(TopNam,TopVal)
	{
	switch (TopNam)
		{
		case "TrapsEna":
			break;
		default:
			aDevArr[TopNam]=TopVal;
		}
	}
	
function F_InTableSize(TopNam,TopVal)
	{
	switch(TopNam)
		{
		case "Dev":
			DeviceSize = parseInt(TopVal,10);
			break;
		case "InpB":
			InpBoolSize = parseInt(TopVal,10);
			break;
		case "OutB":
			OutBoolSize = parseInt(TopVal,10);
			break;
		case "InpI":
			InpIntSize = parseInt(TopVal,10);
			break;
		case "OutI":
			OutIntSize = parseInt(TopVal,10);
			break;
		}
	}

function F_InA(aArr,TopNam,TopVal,iIndx)
	{
	var iI = -1;
	
	switch(TopNam)
		{
		case "Des":
			aArr[iIndx][piDes]=TopVal;
			break;
		case "Msg":
			aArr[iIndx][piMsg]=TopVal;
			break;
		case "Pri": iI=piPri; break;
		case "TTy": iI=piTTy; break;
		case "Ori": iI=piOri; break;
		case "Mod": iI=piMod; break;
		case "Bit": iI=piBit; break;
		case "Fun": iI=piFun; break;
		case "TRe": iI=piTRe; break;
	   case "Del": iI=piDel; break;
	   case "TIP":
	      aArr[iIndx][piTIP]=TopVal;
	      break;
		// Only for analog IO
		case "LLL": iI=piLLL; break;
		case "LoL": iI=piLoL; break;
		case "HiL": iI=piHiL; break;
		case "HHL": iI=piHHL; break;
		case "SMi": iI=piSMi; break;
		case "SMa": iI=piSMa; break;
		case "AMi": iI=piAMi; break;
	   case "AMa": iI=piAMa; break;
		default:
			document.write("Unknown parameter:"+TopNam+"="+TopVal+"<br>");
			break;
		}
		if (iI!=-1)
			{
			aArr[iIndx][iI] = parseInt(TopVal);
			}
	}
	
function ParseSnmpConfigFile(FileArr,bShow,iSnmpIoType)
	{
	var bInDevices=false,bInTableSize=false;
	var bInDI=false,bInDO=false,bInAI=false,bInAO=false;
	var iDiIndx = -1; iDoIndx = -1; iAiIndx = -1; iAoIndx = -1;
	var n,i;
	
	for(i=0; i<FileArr.length; i++)
		{
		switch (FileArr[i].charAt(0))
			{
			case ";":
				continue;
			case "[":
				bInDevices=false;
				bInDI=false;
				bInDO=false;
				bInAI=bInAO=false;
				bInTableSize=false;
				Topic=trim(FileArr[i]);
				switch (Topic)
					{
					case "[TableSize]":
					  bInTableSize=true;
					  break;
					case "[Device]":
						bInDevices=true;
						break;
					default:
						Topic=Topic.substring(0,5);
						switch(Topic)
							{
							case "[InpB":
							  // First time init
							  if (iDiIndx==-1)
									for (n=0; n<InpBoolSize; n++)
										aDiArr[n] = DefaultIO("DI",n);
								bInDI=true;
								re = /\w+/; // search for number
								iDiIndxX=FileArr[i].substring(5,10);
								iDiIndx = parseInt(iDiIndxX,10);
								if (iDiIndx>=InpBoolSize)
									bInDI=false;
								break;
							case "[OutB":
							  if (iDoIndx==-1)
									for (n=0; n<OutBoolSize; n++)
										aDoArr[n] = DefaultIO("DO",n);
								bInDO=true;
								re = /\w+/; // search for number
								iDoIndxX=FileArr[i].substring(5,10);
								iDoIndx = parseInt(iDoIndxX,10);
								if (iDoIndx>=OutBoolSize)
									bInDO=false;
								break;
							case "[InpI":
							  if (iAiIndx==-1)
									for (n=0; n<InpIntSize; n++)
										aAiArr[n] = DefaultIO("AI",n);
								bInAI=true;
								re = /\w+/; // search for number
								iAiIndx = parseInt(FileArr[i].substring(5,10),10);
								if (iAiIndx>=InpIntSize)
									bInAI=false;
								break;
							case "[OutI":
							  if (iAoIndx==-1)
									for (n=0; n<OutIntSize; n++)
										aAoArr[n] = DefaultIO("AO",n);
								bInAO=true;
								re = /\w+/; // search for number
								iAoIndx = parseInt(FileArr[i].substring(5,10),10);
								if (iAoIndx>=OutIntSize)
									bInAO=false;
								break;
							}
						}
				continue;
				}
      iIndx = FileArr[i].search("=");
      TopNam=FileArr[i].substring(0,iIndx);
      TopVal=FileArr[i].substring(iIndx+1,1000);
      if (bInTableSize)
				F_InTableSize(TopNam,TopVal);
			if (bInDevices)
				F_InDevices(TopNam,TopVal);
			else if (bInDI)
				F_InA(aDiArr,TopNam,TopVal,iDiIndx);
			else if (bInDO)
				F_InA(aDoArr,TopNam,TopVal,iDoIndx);
			else if (bInAI)
				F_InA(aAiArr,TopNam,TopVal,iAiIndx);
			else if (bInAO)
				F_InA(aAoArr,TopNam,TopVal,iAoIndx);
		}	
	if (bShow)
		for (i=1; i<=DeviceSize;i++)
			{
			if ('undefined'!=typeof(aDevArr[i]))
				document.write(i+"="+aDevArr[i].toString()+"<br>");
			else
				document.write(i+"=<br>");
			}
	switch (iSnmpIoType)
		{
		case SnmpDi: return InpBoolSize;
		case SnmpDo: return OutBoolSize;
		case SnmpAi: return InpIntSize;
		case SnmpAo: return OutIntSize;
		default: return;
		}
}

function FormatSnmpFile(Editor)
	{
	var time = new Date();
	var lDiArr = new Array();
	var lDoArr = new Array();

	Editor.value =
	  ";***************************************************\r\n"+
		";File saved at:"+time.toUTCString()+" by WebServer\r\n" +
		";***************************************************\r\n";
	Editor.value += "[TableSize]";
	Editor.value += "\r\nDev="+DeviceSize;
	Editor.value += "\r\nInpB="+InpBoolSize;
	Editor.value += "\r\nOutB="+OutBoolSize;
	Editor.value += "\r\nInpI="+InpIntSize;
	Editor.value += "\r\nOutI="+OutIntSize;
	
	Editor.value += "\r\n[Device]\r\n";
	for (i=1; i<=DeviceSize;i++)
		{
		if ('undefined'!=typeof(aDevArr[i]))
			Editor.value += i + "=" + aDevArr[i].toString()+"\r\n";
		else
			Editor.value += i + "=\r\n";
		}
	}

function FormatSnmpIOFile(Editor,SnmpIoType)
	{
	var time = new Date();
	var lArr = new Array();
	var IoStr,Topic,i, strValue = "";
	
	switch (SnmpIoType)
		{
		case SnmpDi:
		  IoStr = "DI";
		  Topic = "[InpB";
			break;
		case SnmpDo:
		  IoStr = "DO";
		  Topic = "[OutB";
			break;
		case SnmpAi:
		  IoStr = "AI";
		  Topic = "[InpI";
			break;
		case SnmpAo:
		  IoStr = "AO";
		  Topic = "[OutI";
			break;
		}
			
	strValue =
		";***************************************************\r\n"+
		";File saved at:"+time.toUTCString()+" by WebServer\r\n" +
		";***************************************************\r\n";
	for (i=0; i<IoTableSize;i++)
		{
		strValue += Topic + i + "]";
		if ((i>=IoArr.length) || ('undefined'==typeof(IoArr[i])))
			lArr = DefaultIO(IoStr,i);
		else
			lArr = IoArr[i];
		strValue += "\r\nDes=" + lArr[piDes] + "\r\nMsg=" + lArr[piMsg] +
			"\r\nPri=" + lArr[piPri] + "\r\nTTy=" + lArr[piTTy] +
			"\r\nOri=" + lArr[piOri] + "\r\nMod=" + lArr[piMod] +
         "\r\nTIP=" + lArr[piTIP];
		if ((SnmpIoType==SnmpDi) || (SnmpIoType==SnmpDo))
			{
			strValue += "\r\nBit=" + lArr[piBit] + "\r\nFun=" + lArr[piFun];
			}
		else if ((SnmpIoType==SnmpAi) || (SnmpIoType==SnmpAo))
			{
			strValue +=
				"\r\nSMi=" + lArr[piSMi] + "\r\nSMa=" + lArr[piSMa] +
				"\r\nAMi=" + lArr[piAMi] + "\r\nAMa=" + lArr[piAMa] +
				"\r\nLLL=" + lArr[piLLL] + "\r\nLoL=" + lArr[piLoL] +
				"\r\nHiL=" + lArr[piHiL] + "\r\nHHL=" + lArr[piHHL];
			}
		strValue +="\r\nTRe=" + lArr[piTRe];
		if ((SnmpIoType==SnmpDi) || (SnmpIoType==SnmpAi))
			strValue +="\r\nDel=" + lArr[piDel];
		strValue += "\r\n";
		}
		Editor.value = strValue;
	}
