﻿//Copyright (c) Brodersen Systems A/S. All rights reserved.
//Written by Beggi Oskarsson
// ------
// 2015/11/02  BO	Adding Trap IP for each I/O
// JScript File
var aDispArr = new Array();
var ItemPrPage = 3;
var CurrentTopItemNo = 0;
var DivDispRangeTop,DivDispRangeEnd;
var IoTableSize = 0;

function MyResetHandler(FormName)
	{
	Form = FindObject(FormName);
	if (!confirm("Are you sure you want to lose all your changes you have made to the SNMP configuration on this page"))
    return;
  // Reset all
	G_Dirty	= false;
  Form.submit();
	}

function ShowHelp(Id)
   {
   switch (Id)
   {
      case "Des":
         Tip("<b>I/O Name</b><br>The \"name\" of the I/O.  Max 30 characters", WIDTH, 300, CLICKSTICKY, true, CLICKCLOSE, true);
         break;
      case "Msg":
         Tip("<b>Message</b><br>Description or the alarm text of the I/O.  Max 255 characters", WIDTH, 300, CLICKSTICKY, true, CLICKCLOSE, true);
         break;
      case "IOT":
         Tip("<b>I/O Address</b><br>The I/O address can either specify a hardware I/O address or a Virtual I/O address 'VIO'", WIDTH, 300, CLICKSTICKY, true, CLICKCLOSE, true);
         break;
      case "SMi":
         Tip("<b>Scaled Min</b><br>Defines the scaled minimum value. The scaled value is the value you want to get/read at the manager.<br><br>Scaling is used for AI/AO I/Os and not for VIO", WIDTH, 300, CLICKSTICKY, true, CLICKCLOSE, true);
         break;
      case "SMa":
         Tip("<b>Scaled Max</b><br>Defines the scaled maximum value. The scaled value is the value you want to get/read at the manager.<br><br>Scaling is used for AI/AO I/Os and not for VIO", WIDTH, 300, CLICKSTICKY, true, CLICKCLOSE, true);
         break;
      case "AMi":
         Tip("<b>HW Signal Min</b><br>HW signal min is the minimum value for the physical input. Normally it is 0.<br><br>Scaling is used for AI/AO I/Os and not for VIO", WIDTH, 300, CLICKSTICKY, true, CLICKCLOSE, true);
         break;
      case "AMa":
         Tip("<b>HW Signal Max</b><br>HW signal max is the maximum value for the physical input. Maximum value depends on the AI resolution:<br><br>16bit: maximum is 65535<br>14bit: maximum is 16383<br>12bit: maximum is 4095<br><br>AI on RTU32 26IO is a 14 bit, some expansion UCL modules are 16 bit others are 12bits.<br><br>Scaling is used for AI/AO I/Os and not for VIO", WIDTH, 300, CLICKSTICKY, true, CLICKCLOSE, true);
         break;
      case "PriD":
         Tip("<b>Trap Priority for Digitial I/O</b><br>Enables and defines the Trap Priority.<br>There are 5 options:<br><br><b>Disabled</b> - (1) disables traps for this I/O<br><b>Warning</b> - (2) will send a warning Trap ID x01 or x11 for this I/O<br><b>Minor</b> - (3) will send a minor Trap ID x02 or x12 for this I/O<br><b>Major</b> - (4) will send a major Trap ID x03 or x13 for this I/O<br><b>Critical</b> - (5) will send a critical Trap ID x04 or x14 for this I/O<br><br>A cleared trap with Trap ID x00 or x10 is always sent when returning from alarm state.", WIDTH, 400, CLICKSTICKY, true, CLICKCLOSE, true);
         break;
      case "PriA":
         Tip("<b>Trap Priority Analogue I/O</b><br>Enables and defines the Trap Priority.<br>There are 6 options:<br><br><b>Disabled</b> - (1) disables traps for this I/O<br><b>Warning</b> - (2) will send a warning Trap ID x01 or x11 for this I/O<br><b>Minor</b> - (3) will send a minor Trap ID x02 or x12 for this I/O<br><b>Major</b> - (4) will send a major Trap ID x03 or x13 for this I/O<br><b>Critical</b> - (5) will send a critical Trap ID x04 or x14 for this I/O<br><b>Limit</b> - (6) will send a limit information traps, lolo,lo,hi,hihi limits with Trap IDs x21..x24 or x31..x34 for this I/O<br><br>A cleared trap with Trap ID x00 or x10 is always sent when returning from alarm state.", WIDTH, 400, CLICKSTICKY, true, CLICKCLOSE, true);
         break;
      case "LoL":
         Tip("<b>Lo Limit</b><br>You can define trap alarms in 4 levels – LoLo, Lo, Hi and HiHi. Level is defined as Scaled Value. If you don’t want to use all levels, you must define the range to be either very high or very low so the actual levels are not reached at any time.", WIDTH, 300, CLICKSTICKY, true, CLICKCLOSE, true);
         break;
      case "LLL":
         Tip("<b>Lo Lo Limit</b><br>You can define trap alarms in 4 levels – LoLo, Lo, Hi and HiHi. Level is defined as Scaled Value. If you don’t want to use all levels, you must define the range to be either very high or very low so the actual levels are not reached at any time.", WIDTH, 300, CLICKSTICKY, true, CLICKCLOSE, true);
         break;
      case "HiL":
         Tip("<b>Hi Limit</b><br>You can define trap alarms in 4 levels – LoLo, Lo, Hi and HiHi. Level is defined as Scaled Value. If you don’t want to use all levels, you must define the range to be either very high or very low so the actual levels are not reached at any time.", WIDTH, 300, CLICKSTICKY, true, CLICKCLOSE, true);
         break;
      case "HHL":
         Tip("<b>Hi Hi Limit</b><br>You can define trap alarms in 4 levels – LoLo, Lo, Hi and HiHi. Level is defined as Scaled Value. If you don’t want to use all levels, you must define the range to be either very high or very low so the actual levels are not reached at any time.", WIDTH, 300, CLICKSTICKY, true, CLICKCLOSE, true);
         break;
      case "Fun":
         Tip("<b>Send Trap Alarm at</b><br>The condition for sending digital alarm.<br><br><b>Rising Edge</b> - transition from OFF to ON<br><b>Falling Edge</b> - transition from ON to OFF<br>", WIDTH, 300, CLICKSTICKY, true, CLICKCLOSE, true);
         break;
      case "TTy":
         Tip("<b>Trap Type</b><br>The Trap Type can either be <b>Non-Informative</b> or <b>Informative</b>.<br><br>Informative traps, contains all user variables inclusive I/O Name and description (alarm text).<br>Non-Informative trap contains the value and the priority and no readable ASCII texts.<br><br><b>Trap IDs</b><br><br> - x01..x04 : sent by Informative traps<br> - x11..x14 : sent by Non-Informative traps<br><br> - 3xx : sent by DI traps<br> - 4xx : sent by AI traps<br> - 6xx : sent by DO traps<br> - 7xx : sent by AO traps<br>", WIDTH, 350, CLICKSTICKY, true, CLICKCLOSE, true);
         break;
      case "TRe":
         Tip("<b>Resend Interval</b><br>When the I/O is in alarm state this parameter defines the resend interval of the trap in minutes. The value 0 disables the resend procedure and means that the Trap is only sent once.", WIDTH, 300, CLICKSTICKY, true, CLICKCLOSE, true);
         break;
      case "Del":
         Tip("<b>Bounce Delay (100msec)</b><br>Defines how long time the alarm state must be active before the alarm trap message is sent.  Entered in number of 100 millisec", WIDTH, 300, CLICKSTICKY, true, CLICKCLOSE, true);
         break;
      case "TIP":
         Tip("<b>Trap Destination</b><br>A trap destination is a combination of a community and IP address.  It is entered in the form:<br><br>community:IPaddr;<br><br>It is possible to enter 4 destinations.<br>Some examples:<br><br>public:192.168.1.123;<br>public:192.168.1.123;users:10.1.1.123;system:192.1.1.234;<br><br>This trap receiver configuration is an alternative to the \"Communities and Trap Receivers\" configuration on the <a href=\"gen_snmp.htm\">SNMP Basic Settings</a> page.<br>If a trap receiver is entered here then the trap will be sent to those addresses and not the one specified on the <a href=\"gen_snmp.htm\">SNMP Basic Settings</a> page.  ", WIDTH, 400, CLICKSTICKY, true, CLICKCLOSE, true);
         break;
      default:
         Tip("No help found for '" + Id + "'", CLICKSTICKY, true, CLICKCLOSE, true);
         break;
      }
   }

function MySubmitHandler(FormName)
{	
	var bOK = true;
	var Form = FindObject(FormName);

	for (i=0; i<ItemPrPage; i++)
		SaveEditFields(i,CurrentTopItemNo+i);

	ClearError();

	// If everything passed then pass this onto the global handler to submit
	if (true == bOK)
		{
		SaveFile(Form);
		return true;
		}
	else
		{		
		FocusFirstError();		
		return false;
		}
}

function TextChange()
{
	G_Dirty = true;
}

function OkToLoseChanges()
    {
    if (G_Dirty)
        {
        if (!confirm("Do you want to loose your changes"))
           return false;
        }
    return true;
    }

function SaveFile(Form)
	{
	var Edit = FindObject("Editor");

	AddSubmitItem(Form, "RTU32EDITOR_SaveFile",FileToSave);		

	Edit.name = "RTU32EDITOR_TextToSave";

	FormatSnmpIOFile(Edit,SnmpIoType);
	AddSubmitItem(Form, "a_REMOTEUTILS_Registry_BootNeeded", "1");
	G_Dirty = false;
	Form.submit();
	}

function ResetEditorForm(Form)
{
   if (!OkToLoseChanges())
      return;
   ClearError();
	
	Form.reset();
	G_Dirty = false;
}

// used to send file back to RTU32
function HiddenEditorDivision()
{
	document.write("<DIV ID=HiddenEditorDivision class=hideform>");
	document.write("<textarea name='Editor' id=Editor>");
	document.write("</textarea></DIV>");
}

function DispTrap(Id)
	{
	document.write("<TR><TD colspan=2>");
	document.write("<DIV ID=DivTrapDisp"+Id+" WIDTH:100%>");
	document.write("<table width=100% border=0>");
	if ((SnmpIoType==SnmpDi) || (SnmpIoType==SnmpDo))
		{
		document.write("<TR><TD>"+Loc('TrapAlarm')+"</TD>");
		document.write("<TD><select class=InputFont id=IoFunc"+Id+" onchange=enableApply();>");
		document.write("    <option value=0 "+(IoArr[Id][piFun]==0?" selected":"") +">"+Loc('RisingEdge'));
		document.write("    <option value=1 "+(IoArr[Id][piFun]==1?" selected":"") +">"+Loc('FallingEdge'));
		document.write("</select>"+AddHelp("Fun")+"</TD></TR>");
		}
	else if ((SnmpIoType==SnmpAi) || (SnmpIoType==SnmpAo))
		{
		document.write("<TR><TD>"+Loc('LoLimit')+"</TD><TD><input class=InputFont type=text onkeyup=enableApply(); id=LoLimit"+Id+" value='"+IoArr[Id][piLoL]+"' size=7>"+AddHelp("LoL")+"</TD>");
		document.write("<TD NOWRAP>"+Loc('LoLoLimit')+"</TD><TD><input class=InputFont type=text onkeyup=enableApply(); id=LoLoLimit"+Id+" value='"+IoArr[Id][piLLL]+"' size=7>"+AddHelp("LLL")+"</TD></TR>");
		document.write("<TR><TD>"+Loc('HiLimit')+"</TD><TD><input class=InputFont type=text onkeyup=enableApply(); id=HiLimit"+Id+" value='"+IoArr[Id][piHiL]+"' size=7>"+AddHelp("HiL")+"</TD>");
		document.write("<TD NOWRAP>"+Loc('HiHiLimit')+"</TD><TD><input class=InputFont type=text onkeyup=enableApply(); id=HiHiLimit"+Id+" value='"+IoArr[Id][piHHL]+"' size=7>"+AddHelp("HHL")+"</TD></TR>");
		}
	document.write("<TR><TD>"+Loc('TrapType')+"</TD>");
		document.write("<TD colspan=3><select class=InputFont id=IoTrapType"+Id+" onchange=enableApply();>");
		document.write("    <option value=0 "+(IoArr[Id][piTTy]==0?" selected":"") +">"+Loc('NonInformative'));
		document.write("    <option value=1 "+(IoArr[Id][piTTy]==1?" selected":"") +">"+Loc('Informative'));
		document.write("</select>" + AddHelp("TTy") + "</TD></TR>");
	document.write("<TR><TD NOWRAP>"+Loc('ResendFreq')+"</TD><TD colspan=3><input class=InputFont type=text onkeyup=enableApply(); id='IoRes"+Id+"' value='"+IoArr[Id][piTRe]+"' size=5>" + AddHelp("TRe") + "</TD></TR>");
	if ((SnmpIoType==SnmpDi) || (SnmpIoType==SnmpAi))
		document.write("<TR><TD NOWRAP>"+Loc('BounceDel')+"</TD><TD colspan=3><input class=InputFont type=text onkeyup=enableApply(); id='IoDel"+Id+"' value='"+IoArr[Id][piDel]+"' size=5>" + AddHelp("Del") + "</TD></TR>");
	document.write("<TR><TD NOWRAP>" + Loc('TrapDest') + "</TD><TD colspan=3><input class=InputFont type=text onkeyup=enableApply(); id='IoTIP" + Id + "' value='" + IoArr[Id][piTIP] + "' size=50>" + AddHelp("TIP") + "</TD></TR>");
	document.write("</table>");
	document.write("</DIV></TD></TR>");
	}

function OnClickShowDiv(Checkbox,DivName)
{
  var On = Checkbox.checked;
  if (On)
     Show(DivName.id);
  else
     Hide(DivName.id);
}

function DispSnmpSettings(Id)
	{
	if (Id>=IoArr.length)
		return;

	document.write("<TR><TD>");
	document.write("<DIV ID=DivIoDisp"+Id+" WIDTH:100% class=SnmpIoEntry>");
	document.write("<b>"+Loc('IO')+" <label id=IdxLabel"+Id+">"+Id+"</label></b>");
	document.write("<br>");
	document.write("<table class=boxInside>")

	document.write("<TR><TD>"+Loc('Name')+"</TD><TD><input class=InputFont type=text onkeyup=enableApply(); id=IoName"+Id+" value='"+IoArr[Id][piDes]+"' size=16>" + AddHelp("Des") + "</TD></TR>");
	document.write("<TR><TD>"+Loc('Msg')+"</TD><TD><input class=InputFont type=text onkeyup=enableApply(); id='IoMsg"+Id+"' value='"+IoArr[Id][piMsg]+"' size=60>" + AddHelp("Msg") + "</TD></TR>");
	document.write("<TR><TD>"+Loc('IoAddr')+"</TD><TD>");
	document.write("<select class=InputFont id=HwType"+Id+" onchange=CheckScaling("+Id+");>");
	document.write("    <option value=2 "+(IoArr[Id][piOri]==2?" selected":"") +">"+IoName);
	document.write("    <option value=3 "+(IoArr[Id][piOri]==3?" selected":"") +">"+'VIO');
	document.write("</select>");
   document.write("<input class=InputFont type=text onkeyup=enableApply(); id=HwModule"+Id+" value='"+IoArr[Id][piMod]+"' size=5>")
	if ((SnmpIoType==SnmpDi) || (SnmpIoType==SnmpDo))
		{
		document.write("<select class=InputFont id=HwBitNo"+Id+" onchange=enableApply();>");
		for (j=0; j<16; j++)
			{
			document.write("<option value="+j+" "+(IoArr[Id][piBit]==j?" selected":"") +">"+j);
			}
		document.write("</select> ");
		}
	document.write(AddHelp("IOT")+"</TD></TR>");
	if ((SnmpIoType==SnmpAi) || (SnmpIoType==SnmpAo))
		{
	   document.write("<TR><TD colspan=2>");
	   document.write("<table><TR><TD>"+Loc('ScaledMin')+"</TD><TD><input class=InputFont type=text onkeyup=enableApply(); id=ScaleMin"+Id+" value='"+IoArr[Id][piSMi]+"' size=7>"+AddHelp("SMi")+"</TD>");
		document.write("<TD>"+Loc('HwMin')+"</TD><TD><input class=InputFont type=text onkeyup=enableApply(); id=HwValMin"+Id+" value='"+IoArr[Id][piAMi]+"' size=7>"+AddHelp("AMi")+"</TD><TD> </TD></TR>");
		document.write("<TR><TD>"+Loc('ScaledMax')+"</TD><TD><input class=InputFont type=text onkeyup=enableApply(); id=ScaleMax"+Id+" value='"+IoArr[Id][piSMa]+"' size=7>"+AddHelp("SMa")+"</TD>");
		document.write("<TD>" + Loc('HwMax') + "</TD><TD><input class=InputFont type=text onkeyup=enableApply(); id=HwValMax" + Id + " value='" + IoArr[Id][piAMa] + "' size=7>"+AddHelp("AMa")+"</TD><TD></TD></TR>");
		document.write("</table></TD></TR>");
	}
	document.write("<TR><TD>"+Loc('Priority')+"</TD><TD>");
	document.write("<select class=InputFont id=IoPriority"+Id+" onchange=TrapPriorityChng("+Id+");>");
	document.write("    <option value=1 "+(IoArr[Id][piPri]==1?" selected":"") +">"+Loc('Disabled'));
	document.write("    <option value=2 "+(IoArr[Id][piPri]==2?" selected":"") +">"+Loc('Warning'));
	document.write("    <option value=3 "+(IoArr[Id][piPri]==3?" selected":"") +">"+Loc('Minor'));
	document.write("    <option value=4 "+(IoArr[Id][piPri]==4?" selected":"") +">"+Loc('Major'));
	document.write("    <option value=5 "+(IoArr[Id][piPri]==5?" selected":"") +">"+Loc('Critical'));
	if ((SnmpIoType==SnmpAi) || (SnmpIoType==SnmpAo))
		document.write("    <option value=6 "+(IoArr[Id][piPri]==6?" selected":"") +">"+Loc('Limit')+"</select>"+AddHelp("PriA"));
	else
      document.write("</select>"+AddHelp("PriD"));    
	document.write("</TD></TR>");
	DispTrap(Id);
	document.write("</table>")
	document.write("</DIV>");
	document.write("</TD></TR>");
	aDispArr[Id] = new Array();
	aDispArr[Id][piDes] = FindObject("IoName"+Id);
	aDispArr[Id][piMsg] = FindObject("IoMsg"+Id);
	aDispArr[Id][piPri] = FindObject("IoPriority"+Id);
	aDispArr[Id][piTTy] = FindObject("IoTrapType"+Id);
	aDispArr[Id][piOri] = FindObject("HwType"+Id);
	aDispArr[Id][piMod] = FindObject("HwModule"+Id);
	if ((SnmpIoType==SnmpDi) || (SnmpIoType==SnmpDo))
		{
		aDispArr[Id][piBit] = FindObject("HwBitNo"+Id);
		aDispArr[Id][piFun] = FindObject("IoFunc"+Id);
		}
	else if ((SnmpIoType==SnmpAi) || (SnmpIoType==SnmpAo))
		{
		aDispArr[Id][piSMi] = FindObject("ScaleMin"+Id);
		aDispArr[Id][piSMa] = FindObject("ScaleMax"+Id);
		aDispArr[Id][piAMi] = FindObject("HwValMin"+Id);
		aDispArr[Id][piAMa] = FindObject("HwValMax"+Id);		
		aDispArr[Id][piLLL] = FindObject("LoLoLimit"+Id);
		aDispArr[Id][piLoL] = FindObject("LoLimit"+Id);
		aDispArr[Id][piHiL] = FindObject("HiLimit"+Id);
		aDispArr[Id][piHHL] = FindObject("HiHiLimit"+Id);
		ToggleScaling(Id);
		}
	aDispArr[Id][piTRe] = FindObject("IoRes"+Id);
	if ((SnmpIoType==SnmpDi) || (SnmpIoType==SnmpAi))
		aDispArr[Id][piDel] = FindObject("IoDel"+Id);
	aDispArr[Id][piTIP] = FindObject("IoTIP" + Id);
	ToggleTrap(Id);
	}

function CheckScaling(Fld)
	{
	ToggleScaling(Fld);
	enableApply();
	}
	
function ToggleScaling(Fld)
	{
	// check if scaling should be grayed or not if VIO is used
	if ((SnmpIoType==SnmpAi) || (SnmpIoType==SnmpAo))
		{
		FldDisabled = (aDispArr[Fld][piOri].value==3)
		aDispArr[Fld][piSMi].disabled = FldDisabled;
		aDispArr[Fld][piSMa].disabled = FldDisabled;
		aDispArr[Fld][piAMi].disabled = FldDisabled;
		aDispArr[Fld][piAMa].disabled = FldDisabled;
		}
	}
	
function TrapPriorityChng(Id)
	{
	ToggleTrap(Id);
	enableApply();
	}

function ToggleTrap(Fld)
	{
	// check if traps should be grayed or not.
	FldDisabled = (aDispArr[Fld][piPri].value==1)
	if ((SnmpIoType==SnmpDi) || (SnmpIoType==SnmpDo))
		aDispArr[Fld][piFun].disabled = FldDisabled;
	else if ((SnmpIoType==SnmpAi) || (SnmpIoType==SnmpAo))
		{
		aDispArr[Fld][piLLL].disabled = FldDisabled;
		aDispArr[Fld][piLoL].disabled = FldDisabled;
		aDispArr[Fld][piHiL].disabled = FldDisabled;
		aDispArr[Fld][piHHL].disabled = FldDisabled;
		}
	aDispArr[Fld][piTTy].disabled = FldDisabled;
	aDispArr[Fld][piTRe].disabled = FldDisabled;
	if ((SnmpIoType==SnmpDi) || (SnmpIoType==SnmpAi))
	   aDispArr[Fld][piDel].disabled = FldDisabled;
	aDispArr[Fld][piTIP].disabled = FldDisabled;
	}

function SnmpTab(First,PrPage)
	{
	document.write("<table>");
	for (p=0; p<PrPage; p++,First++)
		DispSnmpSettings(First);
	document.write("</table>");
	}

function DisplayEditFields(Form,Fld,Idx)
	{
	// Change label value to indicate e.g. SNMP DO(Boolean Output) xx <----
	document.getElementById("IdxLabel"+Fld).innerHTML = Idx;
	aDispArr[Fld][piDes].value = IoArr[Idx][piDes];
	aDispArr[Fld][piMsg].value = IoArr[Idx][piMsg];
	aDispArr[Fld][piPri].value = IoArr[Idx][piPri];
	aDispArr[Fld][piTTy].value = IoArr[Idx][piTTy];
	aDispArr[Fld][piOri].value = IoArr[Idx][piOri];
	aDispArr[Fld][piMod].value = IoArr[Idx][piMod];
	if ((SnmpIoType==SnmpDi) || (SnmpIoType==SnmpDo))
		{
		aDispArr[Fld][piBit].value = IoArr[Idx][piBit];
		aDispArr[Fld][piFun].value = IoArr[Idx][piFun];
		}
	else if ((SnmpIoType==SnmpAi) || (SnmpIoType==SnmpAo))
		{
		aDispArr[Fld][piSMi].value = IoArr[Idx][piSMi];
		aDispArr[Fld][piSMa].value = IoArr[Idx][piSMa];
		aDispArr[Fld][piAMi].value = IoArr[Idx][piAMi];
		aDispArr[Fld][piAMa].value = IoArr[Idx][piAMa];
		aDispArr[Fld][piLLL].value = IoArr[Idx][piLLL];
		aDispArr[Fld][piLoL].value = IoArr[Idx][piLoL];
		aDispArr[Fld][piHiL].value = IoArr[Idx][piHiL];
		aDispArr[Fld][piHHL].value = IoArr[Idx][piHHL];
    ToggleScaling(Fld);
		}
	aDispArr[Fld][piTRe].value = IoArr[Idx][piTRe];
	if ((SnmpIoType==SnmpDi) || (SnmpIoType==SnmpAi))
		aDispArr[Fld][piDel].value = IoArr[Idx][piDel];
	aDispArr[Fld][piTIP].value = IoArr[Idx][piTIP];
	ToggleTrap(Fld);
	}

function SaveEditFields(Fld,Idx)
  {
	IoArr[Idx][piDes] = aDispArr[Fld][piDes].value;
	IoArr[Idx][piMsg] =	aDispArr[Fld][piMsg].value;
	IoArr[Idx][piPri] =	aDispArr[Fld][piPri].value;
	IoArr[Idx][piTTy] =	aDispArr[Fld][piTTy].value;
	IoArr[Idx][piOri] =	aDispArr[Fld][piOri].value;
	IoArr[Idx][piMod] =	aDispArr[Fld][piMod].value;
	if ((SnmpIoType==SnmpDi) || (SnmpIoType==SnmpDo))
		{
		IoArr[Idx][piBit] =	aDispArr[Fld][piBit].value;
		IoArr[Idx][piFun] =	aDispArr[Fld][piFun].value;
		}
	else if ((SnmpIoType==SnmpAi) || (SnmpIoType==SnmpAo))
		{
		IoArr[Idx][piSMi] = aDispArr[Fld][piSMi].value;
		IoArr[Idx][piSMa] = aDispArr[Fld][piSMa].value;
		IoArr[Idx][piAMi] = aDispArr[Fld][piAMi].value;
		IoArr[Idx][piAMa] = aDispArr[Fld][piAMa].value;
		IoArr[Idx][piLLL] = aDispArr[Fld][piLLL].value;
		IoArr[Idx][piLoL] = aDispArr[Fld][piLoL].value;
		IoArr[Idx][piHiL] = aDispArr[Fld][piHiL].value;
		IoArr[Idx][piHHL] = aDispArr[Fld][piHHL].value;
		}
	IoArr[Idx][piTRe] =	aDispArr[Fld][piTRe].value;
	if ((SnmpIoType==SnmpDi) || (SnmpIoType==SnmpAi))
		IoArr[Idx][piDel] =	aDispArr[Fld][piDel].value;
	IoArr[Idx][piTIP] = aDispArr[Fld][piTIP].value;
}
  
function DispRange()
	{
	DivDispRangeEnd.innerHTML = DivDispRangeTop.innerHTML = "<b>" +CurrentTopItemNo.toString()+"</b>..<b>"+(CurrentTopItemNo+ItemPrPage-1)+"</b> of <b>"+(IoTableSize-1).toString()+"</b>";
	}
	
function BrowseUp(Form,Scroll)
	{
	for (i=0; i<ItemPrPage; i++)
		SaveEditFields(i,CurrentTopItemNo+i);

  CurrentTopItemNo -= Scroll;
	if (CurrentTopItemNo<0)
		CurrentTopItemNo=0;
	
	DispRange()
	for (i=0; i<ItemPrPage; i++)
		DisplayEditFields(Form,i,CurrentTopItemNo+i);
	}
	
function BrowseDown(Form,Scroll)
	{
	for (i=0; i<ItemPrPage; i++)
		SaveEditFields(i,CurrentTopItemNo+i);
	
	CurrentTopItemNo += Scroll;
	if (CurrentTopItemNo>=(IoTableSize-ItemPrPage))
		CurrentTopItemNo=IoTableSize-ItemPrPage;
		
	DispRange()
	for (i=0; i<ItemPrPage; i++)
		DisplayEditFields(Form,i,CurrentTopItemNo+i);
	}
	
function NewItemPrPage(Cb)
	{
	SetCookie("SelectedItemPrPage",Cb.value);
	Cb.form.submit();
	}
	
function BrowseButtons(Top)
	{
	document.write("<div align=right>");
	if (Top)
		document.write("<div class=InputFont id=DivDispRangeTop>1/2</div>");
	document.write("<input class=InputFont id=HomeButton type=button value='top' onclick=BrowseUp(this.form,1000)>");
	document.write("<input class=InputFont id=PgUpButton type=button value='<<' onclick=BrowseUp(this.form,ItemPrPage)>");
	document.write("<input class=InputFont id=UpButton type=button value='<' onclick=BrowseUp(this.form,1)>");
	document.write("<input class=InputFont id=DownButton type=button value='>' onclick=BrowseDown(this.form,1)>");
	document.write("<input class=InputFont id=PgDownButton type=button value='>>' onclick=BrowseDown(this.form,ItemPrPage)>");
	document.write("<input class=InputFont id=EndButton type=button value='end' onclick=BrowseDown(this.form,1000)> ");
	document.write("<select class=InputFont id=CbItemPrPage onchange=NewItemPrPage(this)>");
	document.write("<option value=2 "+(ItemPrPage==2?" selected":"") +">2");
	document.write("<option value=3 "+(ItemPrPage==3?" selected":"") +">3");
	document.write("<option value=4 "+(ItemPrPage==4?" selected":"") +">4");
	document.write("<option value=5 "+(ItemPrPage==5?" selected":"") +">5");
	document.write("<option value=8 "+(ItemPrPage==8?" selected":"") +">8");
	document.write("<option value=10 "+(ItemPrPage==10?" selected":"") +">10");
	document.write("<option value=16 "+(ItemPrPage==16?" selected":"") +">16");
	document.write("<option value=20 "+(ItemPrPage==20?" selected":"") +">20");
	document.write("</select> pr.pg");
  if (!Top)
		{
		document.write("<div class=InputFont id=DivDispRangeEnd>1/2</div>");		
		}
	document.write("</div>");
	}
	
function ShowPage()
	{
	document.write("<form METHOD=post accept-charset=\"utf-8\" name=EditForm onsubmit='return MySubmitHandler(\"EditForm\")' onreset=MyResetHandler('EditForm')>");
	BuildBoxHeader();

	IoTableSize = ParseSnmpConfigFile(g_RTU32EDITOR_,false,SnmpIoType);
	ParseSnmpConfigFile(g_RTU32EDITOR_IO,false,-1);
	ItemPrPage = GetCookie("SelectedItemPrPage");
	if (ItemPrPage==null)
		ItemPrPage=3;
	else
	  ItemPrPage=parseInt(ItemPrPage,10);
	if (ItemPrPage>IoTableSize)
		ItemPrPage=IoTableSize;

	document.write("<table width=100%>");
	AddSection(Loc('Header'),"");
	//document.write("<TR><TD colspan=5 align=left>");
	BrowseButtons(false);
	
	SnmpTab(0,ItemPrPage);

	BrowseButtons(true);
  	
	//document.write("</TD></TR></table>");
	DivDispRangeTop = FindObject("DivDispRangeTop");
	DivDispRangeEnd = FindObject("DivDispRangeEnd");
	BuildBoxFooter();
	AddApplyCancel('EditForm');
	HiddenEditorDivision();
	document.write("</form>");
	DispRange()
	AdjustFormView();
}

function BuildPageHeader(Title)
{
	document.write("<meta http-equiv='Content-Language' content='en-us'>");
	document.write("<meta http-equiv='Content-Type' content='text/html; charset=UTF-8'>");
	document.write("<title class=pageHeadText>" + ProductName + Title + "</title>");
}

function BuildBody(Title,Description,MainFunction)
	{
		BuildMainTable(Title, Description, MainFunction);
		AddErrorDisplay();
		ClearError();
	}